//---------------------------------------------------------------------------

#ifndef frmThreadH
#define frmThreadH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------

class TForm1 : public TForm
{
__published:	//IDE-managed Components
    TTimer *T1;
    TTimer *T2;
    TTimer *T3;
    TCheckBox *EnabledTimer1;
    TCheckBox *EnabledTimer2;
    TCheckBox *EnabledTimer3;
    TMemo *memoMSG;
    TButton *B1;
    TListBox *lisID;
    TCheckBox *chkSuspend;
    TCheckBox *chkShowProcessRunning;
    TProgressBar *ProgressBar1;
    TLabel *Label1;
    TButton *butDeleteSuspend;
    TGroupBox *GroupBox1;
    TRadioButton *RadioButton1;
    TRadioButton *RadioButton2;
    TGroupBox *GroupBox2;
    TRadioButton *rbSlow;
    TRadioButton *rbFast;
    TLabel *Label3;
    TLabel *labCount;
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall chkSuspendClick(TObject *Sender);
    void __fastcall B1Click(TObject *Sender);
    void __fastcall EnabledTimer1Click(TObject *Sender);
    void __fastcall butDeleteSuspendClick(TObject *Sender);
    void __fastcall RadioButton1Click(TObject *Sender);
    void __fastcall RadioButton2Click(TObject *Sender);
private:	// User declarations
    TList *lisThread;
    int iMaxThreadID;
    bool bThreadRunning;
    bool bSuspendAfterTheLastOneThreadFinishes;
    void CreateMyThread(AnsiString tControlName);
    void ClearThreadList();
public:		// User declarations
    __fastcall TForm1(TComponent* Owner);
    void __fastcall MyThreadOnFinish(TObject* Sender,int iThreadID);
};

//---------------------------------------------------------------------------

//ۭqƥ󪺫ŧi
//TThreadwg@OnTerminateƥܦn
//o̥ܽdpۭqƥAüW[ѼơAݭnɭԨϥ
typedef void __fastcall (__closure *TMyThreadEvent)
   (System::TObject* Sender,
            int iThreadID);

//C|ThreadDnu@ت
enum BusyType{Slow,Fast};

//---------------------------------------------------------------------------

class TMyThread : public TThread
{
public:
    __fastcall TMyThread(void);

    //ܼƳzLݩʨӦsˬdXz
    //ܽdUثAݩʡAƥAC|
    __property int MyThreadID = { read=iMyThreadID, write=iMyThreadID };
    __property AnsiString MyTargetControl = { read=sMyTargetControl, write=sMyTargetControl };
    __property TMyThreadEvent OnThreadFinish = {read=FOnThreadFinish, write=FOnThreadFinish};
    __property BusyType MyBusyType = {read=mbType, write=mbType};

    __fastcall ~TMyThread(void);

private:

    //ܼƤwzLݩʨӦsAGPrivateO@A}
    TMyThreadEvent FOnThreadFinish;                 //ۭqƥܼ
    AnsiString sMyTargetControl;
    int iMyThreadID;
    int iShowProcess;
    bool bAutoCheck;
    BusyType mbType;                                //C|

    void __fastcall ThreadSlowMain();
    void __fastcall ThreadFastMain();
    void __fastcall Execute(void);
};

//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
